package cpcns.danganzhengli.shengjijuxiangmu.service.impl;

package .tmp;

import cpcns.base.common.User;
import cpcns.common.service.impl.commonServiceImpl;
import cpcns.danganzhengli.shengjijuxiangmu.dao.IDShenJiJuXiangMuDao;
import cpcns.danganzhengli.shengjijuxiangmu.model.DShenJiJuXiangMu;
import cpcns.danganzhengli.shengjijuxiangmu.service.IDShenJiJuXiangMuService;
import cpcns.danganzhengli.wenshu.wenjian.dao.IDWenJianDao;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import org.apache.commons.lang.StringUtils;

public class DShenJiJuXiangMuServiceImpl extends commonServiceImpl<DShenJiJuXiangMu> implements IDShenJiJuXiangMuService {
  private IDShenJiJuXiangMuDao dShenJiJuXiangMuDao;
  
  private IDWenJianDao dWenJianDao;
  
  public IDWenJianDao getdWenJianDao() {
    return this.dWenJianDao;
  }
  
  public IDShenJiJuXiangMuDao getdShenJiJuXiangMuDao() {
    return this.dShenJiJuXiangMuDao;
  }
  
  public void setdShenJiJuXiangMuDao(IDShenJiJuXiangMuDao dShenJiJuXiangMuDao) {
    this.dShenJiJuXiangMuDao = dShenJiJuXiangMuDao;
  }
  
  public void setdWenJianDao(IDWenJianDao dWenJianDao) {
    this.dWenJianDao = dWenJianDao;
  }
  
  public void updateAnJuan(Map<String, String> map1, Map<String, String> map2) {
    StringBuffer sql = new StringBuffer(" Update D_ShenJiJuXiangMu set ");
    String t_sql = "";
    for (Map.Entry<String, String> entry : map2.entrySet()) {
      if (t_sql == "") {
        t_sql = String.valueOf(entry.getKey()) + "=" + (String)entry.getValue();
        continue;
      } 
      t_sql = String.valueOf(t_sql) + "," + (String)entry.getKey() + "=" + (String)entry.getValue();
    } 
    sql.append(t_sql).append(" where ");
    for (Map.Entry<String, String> entry : map1.entrySet())
      sql.append(String.valueOf(entry.getKey()) + " in ( " + (String)entry.getValue()).append(" )"); 
    this.dShenJiJuXiangMuDao.updateAnJuan(sql.toString());
  }
  
  public void updateQiZhiShiJian(String server, String hangBiaoShis) {
    if (StringUtils.isNotBlank(hangBiaoShis)) {
      String[] str = hangBiaoShis.split(",");
      if (str.length > 0)
        for (int i = 0; i < str.length; i++) {
          String hangBiaoShi = str[i];
          String qiShiJian = this.dWenJianDao.getChengWenShiJian(hangBiaoShi, 2);
          String zhiShiJian = this.dWenJianDao.getChengWenShiJian(hangBiaoShi, 1);
          StringBuffer sql = new StringBuffer();
          if (StringUtils.isNotBlank(qiShiJian)) {
            sql.append(" Update D_ShenJiJuXiangMu set qiShiJian = '" + qiShiJian + "',zhiShiJian='" + zhiShiJian + "' where hangBiaoShi =" + hangBiaoShi);
          } else {
            sql.append(" Update D_ShenJiJuXiangMu set qiShiJian = null,zhiShiJian= null where hangBiaoShi =" + hangBiaoShi);
          } 
          this.dShenJiJuXiangMuDao.updateAnJuan(sql.toString());
        }  
    } 
  }
  
  public void updateAnJuanZhuangTai(String hangBiaoShis, Integer zhuangTai) {
    StringBuffer sql = new StringBuffer();
    Date date = new Date();
    DateFormat format = new SimpleDateFormat("yyyy-MM-dd");
    String time = format.format(date);
    sql.append("update D_ShenJiJuXiangMu set zhuangTai = " + zhuangTai + " where guanLianBiaoShi in (" + hangBiaoShis + ") or hangBiaoShi in( " + hangBiaoShis + " )");
    this.dShenJiJuXiangMuDao.deletSQL(sql.toString());
    String[] str = hangBiaoShis.split(",");
    String ajhbs = "";
    String ajhbs_all = "";
    if (str.length > 0)
      for (int i = 0; i < str.length; i++) {
        StringBuffer ansql = null;
        ansql = new StringBuffer(" select hangBiaoShi from D_ShenJiJuXiangMu where guanlianbiaoshi in(" + str[i] + ")");
        List ls = this.dShenJiJuXiangMuDao.getData(ansql);
        StringBuffer sqls = new StringBuffer();
        sqls.append("update D_wenJian set zhuangTai = " + zhuangTai);
        if (zhuangTai.intValue() == 0) {
          sqls.append(", guiDangRiQi =to_date(null,'yyyy-MM-dd')");
        } else {
          sqls.append(", guiDangRiQi =to_date('").append(time).append("','yyyy-MM-dd')");
        } 
        if (ls.size() > 0) {
          for (Iterator<Map<String, Object>> fj = ls.iterator(); fj.hasNext(); ) {
            Map<String, Object> fjobj = fj.next();
            ajhbs = (fjobj.get("HANGBIAOSHI") != null) ? fjobj.get("HANGBIAOSHI").toString() : "";
            if (ajhbs_all == null || ajhbs_all == "") {
              ajhbs_all = ajhbs;
              continue;
            } 
            ajhbs_all = String.valueOf(ajhbs_all) + "," + ajhbs;
          } 
          sqls.append(" where guiDangLeiXing = 1 and guanLianBiaoShi  in( " + ajhbs_all + " )");
        } 
        this.dShenJiJuXiangMuDao.deletSQL(sqls.toString());
      }  
  }
  
  public List<Map<String, Object>> getDate(String table, String sqlWhere, User user) {
    String[] ms = sqlWhere.split("and");
    String tj = parseTJ(ms);
    StringBuffer sql = null;
    sql = (new StringBuffer(" select baoGuanQiXian,zongYeShu,biaoTi,guiDangNianDu,beiZhu,xuHao,guanBianAnjuanHao from ")).append(table).append(tj);
    sql.append("  order by xuHao asc");
    List<Map<String, Object>> list = this.dShenJiJuXiangMuDao.getData(sql);
    return list;
  }
  
  private String parseTJ(String[] ms) {
    String sql = "";
    String hbssql = "";
    if (ms.length > 0) {
      byte b;
      int i;
      String[] arrayOfString;
      for (i = (arrayOfString = ms).length, b = 0; b < i; ) {
        String m = arrayOfString[b];
        if (m.contains("hbs")) {
          String[] hbs = m.split("=");
          if (hbs.length == 2 && StringUtils.isNotBlank(hbs[1].trim()))
            hbssql = " where hangBiaoShi in (" + hbs[1].trim().replaceAll("'", "") + ")"; 
        } else if (!m.contains("_") && !m.contains("hbs")) {
          sql = String.valueOf(sql) + m + " and ";
        } 
        b++;
      } 
      sql = " where 1=1 and " + sql;
    } 
    if (hbssql.length() > 0)
      sql = hbssql; 
    if (sql.trim().endsWith("and"))
      sql = sql.substring(0, sql.length() - 4); 
    return sql;
  }
  
  public int getZongYeShu(String server, String glbm, String hbs) {
    StringBuffer sql = new StringBuffer();
    sql.append(" select sum(zongYeShu) from " + glbm);
    sql.append(" where 1=1 and guanLianBiaoShi in ('").append(hbs).append("')");
    int zongYeShu = 0;
    zongYeShu = this.dShenJiJuXiangMuDao.getWenJianYeShu(sql.toString());
    return zongYeShu;
  }
}
